Graphics 640, 480, 32, 2
SetBuffer BackBuffer()
Cls


Global font= LoadFont("Arial", 30)
Global smallfont = LoadFont("Arial", 16)
SetFont font

Global r, g, b = 0
Global myspeed, mxspeed, mdr, curID, still_in=False, curr_P_ID=0, p_count=0, st=False, ID_counter=0, g_max=0
Global pnextx, pnexty, timer, swap=False

Const accuracy=10


Type gesture
	Field ID
	Field r, gr, b
	Field pcount
End Type 

Type points
	Field ID
	Field x, y
	Field gID
End Type 

;get own gestures from file
ID_counter = 0
p_ID_counter= 0

f=ReadFile("mygesture.txt")
While Not(Eof(f))
	re$=ReadLine(f)
	If re$="New" Then 
		ge.gesture = New gesture
		ge\ID = ID_counter
		ge\r  = ReadLine(f)
		ge\gr = ReadLine(f)
		ge\b  = ReadLine(f)
		
		
		Repeat 
			rl$=ReadLine(f)
			If rl$= "End" Then Exit 
			p.points = New points
			p\ID	 = p_ID_counter
			p\gID	 = ge\ID
			p\x		 = Int(rl)
			p\y		 = ReadLine(f)
			p_ID_counter = p_ID_counter + 1
		Forever
		ge\pcount=p\ID
		
		ID_counter = ID_counter+1 
		p_ID_counter=0	
	EndIf 
Wend 
CloseFile(f) 


g_max= ID_Counter				


;Mainloop
While Not(KeyDown(1))
Cls
	mdl=MouseDown(1)
	mdr=MouseDown(2)
	mxspeed=MouseXSpeed()
	myspeed=MouseYSpeed()
	
	If mdl Then 
		Text GraphicsWidth()/2-150, GraphicsHeight()/2-50, "Wipe to change color!"
		getsimplegesture()
	EndIf 
	
	If mdr Then 
		If MilliSecs()>timer Then
			getowngesture()		
			still_in=False
		EndIf 
		
		st=False 
		curr_P_ID=0
		curID=0
		pnextx=0
		pnexty=0
		 
	EndIf 
	
	ClsColor r, g, b 
	Flip(0)
Wend 


Function getsimplegesture()
	;x
	If mxspeed > 0 And myspeed<20 And myspeed> -20 Then 
		r=r+mxspeed
	ElseIf  mxspeed < 0 And myspeed<20 And myspeed> -20 Then 
		b=b+mxspeed
	EndIf 
	;y
	If myspeed > 0 And mxspeed<20 And mxspeed> -20 Then 
		g=g+myspeed
	ElseIf  myspeed < 0 And mxspeed<20 And mxspeed> -20 Then 
		g=g+Rand(30)
		r=r+Rand(30)
		b=b+Rand(30)
	EndIf 	
End Function 	

Function getowngesture()
		While mdr
			mdr=MouseDown(2)
			Cls 
			For  p.points = Each points
				If p\gID = curID Then 
					;draw crosses
					SetFont smallfont
					Color r+100, g+100, b+100
					Text p\x-3, p\y-20, p\ID+1
					Line p\x-5, p\y-5, p\x+5, p\y+5
					Line p\x-5, p\y+5, p\x+5, p\y-5
					Color 255, 255, 255
					SetFont font
					
					If p\ID = 0 And still_in= False Then 
						MoveMouse(p\x, p\y)
						still_in= True
					EndIf 
						
					;connect				
					Mox= MouseX()
					moy= MouseY()
					If p\ID=curr_P_ID+1 Then
						pnextx = p\x
						pnexty = p\y
						swap=False 
					EndIf
					 
					If mox<pnextx+accuracy And moy<pnexty+accuracy And mox>pnextx-accuracy And moy<pnexty+accuracy
						If swap=False Then 
							curr_P_ID=curr_P_ID+1
							swap=True 
						EndIf 					
					EndIf
					
					For ge.gesture = Each gesture
							If curr_P_ID>=ge\pcount Then 
	
								If ge\ID = curID Then 
									r= ge\r 
									g= ge\gr
									b= ge\b
									st=True
									timer=MilliSecs()+1000 
								EndIf
							EndIf
					Next 
				EndIf
			Next  
			
			mdm = MouseZSpeed()
			Select mdm
				Case -1
					If curID-1<0 Then 
						curID=g_max
					Else
						curID=curID-1
					EndIf 
					still_in =False
				Case 1 
					If curID+2>g_max Then 
						curID=0
					Else 
						curID=curID+1
					EndIf 
					still_in=False 
			End Select 
					
			If g_max=0 Then 
				Text GraphicsWidth()/2-150, GraphicsHeight()/2-50, "No own gesture assigned!"
			EndIf 
			
 			If st=True Then Exit 
			
			Flip(0) 
		Wend 
	
End Function 




















